USE J000001_LoadDB;

-- LoadCSVFileIntoTable
BULK INSERT P2Detection FROM 'C:\PC3\SampleData\J062941\P2_J062941_B001_P2fits2_20081115_P2Detection.csv'
	WITH(BATCHSIZE=10000, CODEPAGE='raw', FIELDTERMINATOR=',',
  FIRSTROW=1, MAXERRORS=0, ROWTERMINATOR='0x0A', TABLOCK )
              
BULK INSERT P2FrameMeta FROM 'C:\PC3\SampleData\J062941\P2_J062941_B001_P2fits0_20081115_P2FrameMeta.csv'
	WITH(BATCHSIZE=10000, CODEPAGE='raw', FIELDTERMINATOR=',',
	FIRSTROW=1, MAXERRORS=0, ROWTERMINATOR='0x0A', TABLOCK );

BULK INSERT P2ImageMeta FROM 'C:\PC3\SampleData\J062941\P2_J062941_B001_P2fits2_20081115_P2ImageMeta.csv'
	WITH(BATCHSIZE=10000, CODEPAGE='raw', FIELDTERMINATOR=',',
  FIRSTROW=1, MAXERRORS=0, ROWTERMINATOR='0x0A', TABLOCK );


-- UpdateComputedColumns
UPDATE P2Detection SET zoneID = ("dec"+(90.0))/(0.0083333);

UPDATE P2Detection SET cx = (COS(RADIANS("dec"))*COS(RADIANS(ra)));

UPDATE P2Detection SET cy = COS(RADIANS("dec"))*SIN(RADIANS(ra));

UPDATE P2Detection SET cz = (SIN(RADIANS("dec")));


-- IsMatchTableRowCount
SELECT COUNT(*) FROM P2Detection;

SELECT COUNT(*) FROM P2FrameMeta;

SELECT COUNT(*) FROM P2ImageMeta;


-- IsMatchTableColumnRanges
SELECT COUNT(*) FROM P2Detection WHERE (ra < 0 OR ra > 360) AND ra" != -999;

SELECT COUNT(*) FROM P2Detection WHERE ("dec" < -90 OR "dec" > 90) AND "dec" != -999;

SELECT COUNT(*) FROM P2Detection WHERE (raErr < -2000 OR raErr > 9) AND raErr != -999;

SELECT COUNT(*) FROM P2Detection WHERE (decErr < 0 OR decErr > 9) AND decErr != -999;


-- CompactDatabase
DBCC SHRINKDATABASE (J000001_LoadDB);